/*! \file lib_io_tp.cpp
    \brief Librairie E/S via TCP pour le CESI.
    \author Bertrand Vandeportaele IUT GEII
    \date  14/02/2022
*/

#include "lib_io_tp.h"

char ipAddress[4*4+1]; // = "127.0.0.1"; //assez de caractères pour stocker une adresse quelconque
char portNum[7];//="4242";
addrinfo *p_addrinfo;
int sockFD;


int setupES(char *ipAddressInit,char *portNumInit){
    std::cout << "ouverture socket vers : " << ipAddressInit << " : " <<portNumInit << std::endl;
    char * ptr=ipAddress;
    while ((*ipAddressInit)!=0){
        *ptr=*ipAddressInit;
        ipAddressInit++;
        ptr++;
    }
    ptr=portNum;
        while ((*portNumInit)!=0){
            *ptr=*portNumInit;
            portNumInit++;
            ptr++;
        }


    addrinfo hints;

    memset(&hints, 0, sizeof(hints));
    hints.ai_family   = AF_UNSPEC;
    hints.ai_socktype = SOCK_STREAM;
    hints.ai_flags    = AI_PASSIVE;

    int gAddRes = getaddrinfo(ipAddress, portNum, &hints, &p_addrinfo);
    if (gAddRes != 0) {
        std::cerr << gai_strerror(gAddRes) << "\n";
        return -2;
    }

    if (p_addrinfo == NULL) {
        std::cerr << "No addresses found\n";
        return -3;
    }

    // socket() call creates a new socket and returns it's descriptor
    sockFD = socket(p_addrinfo->ai_family, p_addrinfo->ai_socktype, p_addrinfo->ai_protocol);
    if (sockFD == -1) {
        std::cerr << "Error while creating socket\n";
        return -4;
    }

    // Note: there is no bind() call as there was in Hello TCP Server
    // why? well you could call it though it's not necessary
    // because client doesn't necessarily has to have a fixed port number
    // so next call will bind it to a random available port number

    // connect() call tries to establish a TCP connection to the specified server
    int connectR = connect(sockFD, p_addrinfo->ai_addr, p_addrinfo->ai_addrlen);
    if (connectR == -1) {
        close(sockFD);
        std::cerr << "Error while connecting socket\n";
        return -5;
    }
    std::cout << "ouverture socket vers : " << ipAddressInit << " : " <<portNumInit << " réussie" <<std::endl;
    return 0; // no problem
}
//////////////////////////////////////
void closeES(){
    close(sockFD);
    freeaddrinfo(p_addrinfo);
}
//////////////////////////////////////
/// \brief readPort
/// \return
///
unsigned char readPort(void){
    //requete g:

    // Send N bytes of BUF to socket FD.  Returns the number sent or -1.
    //extern ssize_t send (int __fd, const void *__buf, size_t __n, int __flags);
    char buffer[2000]; //>MTU
    sprintf(buffer,"g 000\n");
    size_t sz=strlen(buffer);
    //auto bytes_send =
    send(sockFD, buffer, sz, 0);

    //réponse:
    std::string reply(15, ' ');

    // recv() call tries to get the response from server
    // BUT there's a catch here, the response might take multiple calls
    // to recv() before it is completely received
    // will be demonstrated in another example to keep this minimal
    auto bytes_recv = recv(sockFD, &reply.front(), reply.size(), 0);
    if (bytes_recv == -1) {
        std::cerr << "Error while receiving bytes\n";
        //    return -6;
    }

    //std::cout << "\nClient received: " << reply << std::endl;
    //parsing réponse
    unsigned char ret=stoi(reply);
    std::cout << "\nreadPort : " << static_cast<int>(ret) << std::endl;
    return ret;
}
//////////////////////////////////////
/// \brief writePort
/// \param value
///
void writePort(unsigned char value){
    //requete s value:

    // Send N bytes of BUF to socket FD.  Returns the number sent or -1.
    //extern ssize_t send (int __fd, const void *__buf, size_t __n, int __flags);
    char buffer[2000]; //>MTU
    sprintf(buffer,"s %03d\n",value);
    size_t sz=strlen(buffer);
    //auto bytes_send =
    send(sockFD, buffer, sz, 0);


    //réponse: (je met aussi une réponse comme ca writePort vide les buffers et attends une réponse, le serveur voit les requetes 1 par 1, qu'elles soient g ou s
    std::string reply(15, ' ');

    // recv() call tries to get the response from server
    // BUT there's a catch here, the response might take multiple calls
    // to recv() before it is completely received
    // will be demonstrated in another example to keep this minimal
    auto bytes_recv = recv(sockFD, &reply.front(), reply.size(), 0);
    if (bytes_recv == -1) {
        std::cerr << "Error while receiving bytes\n";
        //    return -6;
    }
    //parsing réponse
    unsigned char ret=stoi(reply);
    std::cout << "\nwritePort "<< static_cast<int>(value) << " : " << static_cast<int>(ret) << std::endl;
    //parsing réponse
    //return (char)stoi(reply);
    return;
}

//////////////////////////////////////
/// \brief setName
/// \param value
///
void setName(char *value){
    //requete n value:

    // Send N bytes of BUF to socket FD.  Returns the number sent or -1.
    //extern ssize_t send (int __fd, const void *__buf, size_t __n, int __flags);
    char buffer[2000]; //>MTU
    sprintf(buffer,"n %s\n",value);
    size_t sz=strlen(buffer);
    //auto bytes_send =
    send(sockFD, buffer, sz, 0);


    //réponse: (je met aussi une réponse comme ca writePort vide les buffers et attends une réponse, le serveur voit les requetes 1 par 1, qu'elles soient g ou s
    std::string reply(15, ' ');

    // recv() call tries to get the response from server
    // BUT there's a catch here, the response might take multiple calls
    // to recv() before it is completely received
    // will be demonstrated in another example to keep this minimal
    auto bytes_recv = recv(sockFD, &reply.front(), reply.size(), 0);
    if (bytes_recv == -1) {
        std::cerr << "Error while receiving bytes\n";
        //    return -6;
    }
    //parsing réponse
    unsigned char ret=stoi(reply);
    std::cout << "\nsetName "<< value << " : " << static_cast<int>(ret) << std::endl;
    //parsing réponse
    //return (char)stoi(reply);
    return;
}

//////////////////////////////////////
/// \brief setMsg
/// \param value
///
void setMsg(char *value){
    //requete n value:

    // Send N bytes of BUF to socket FD.  Returns the number sent or -1.
    //extern ssize_t send (int __fd, const void *__buf, size_t __n, int __flags);
    char buffer[2000]; //>MTU
    sprintf(buffer,"m %s\n",value);
    size_t sz=strlen(buffer);
    //auto bytes_send =
    send(sockFD, buffer, sz, 0);


    //réponse: (je met aussi une réponse comme ca writePort vide les buffers et attends une réponse, le serveur voit les requetes 1 par 1, qu'elles soient g ou s
    std::string reply(15, ' ');

    // recv() call tries to get the response from server
    // BUT there's a catch here, the response might take multiple calls
    // to recv() before it is completely received
    // will be demonstrated in another example to keep this minimal
    auto bytes_recv = recv(sockFD, &reply.front(), reply.size(), 0);
    if (bytes_recv == -1) {
        std::cerr << "Error while receiving bytes\n";
        //    return -6;
    }
    //parsing réponse
    unsigned char ret=stoi(reply);
    std::cout << "\nsetName "<< value << " : " << static_cast<int>(ret) << std::endl;
    //parsing réponse
    //return (char)stoi(reply);
    return;
}
